Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent
Class LinkedBlockingDeque

    java.lang.Object
      java.util.AbstractCollection
          edu.emory.mathcs.backport.java.util.AbstractCollection
              edu.emory.mathcs.backport.java.util.AbstractQueue
                  edu.emory.mathcs.backport.java.util.concurrent.LinkedBlockingDeque

All Implemented Interfaces:
  BlockingDeque, BlockingQueue, java.util.Collection, Deque, Queue, java.io.Serializable

public class LinkedBlockingDeque
extends AbstractQueue
implements BlockingDeque, java.io.Serializable

An optionally-bounded blocking deque based on linked nodes.

The optional capacity bound constructor argument serves as a way to prevent excessive expansion. The capacity, if unspecified, is equal to `Integer.MAX_VALUE`. Linked nodes are dynamically created upon each insertion unless this would bring the deque above capacity.

Most operations run in constant time (ignoring time spent blocking). Exceptions include `remove`, `removeFirstOccurrence`, `removeLastOccurrence`, `contains`, `iterator.remove()`, and the bulk operations, all of which run in linear time.

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces.

This class is a member of the Java Collections Framework.

Since:
  1.6
Author:
  Doug Lea
See Also:
  Serialized Form

Constructor Summary
`LinkedBlockingDeque()` Creates a `LinkedBlockingDeque` with a capacity of `Integer.MAX_VALUE`.
`LinkedBlockingDeque(java.util.Collection c)` Creates a `LinkedBlockingDeque` with a capacity of `Integer.MAX_VALUE`, initially containing the elements of the given collection, added in traversal order of the collection's iterator.
`LinkedBlockingDeque(int capacity)` Creates a `LinkedBlockingDeque` with the given (fixed) capacity.

Method Summary
`boolean` | `add(java.lang.Object e)` Inserts the specified element at the end of this deque unless it would violate capacity restrictions.
`void` | `addFirst(java.lang.Object e)` Inserts the specified element at the front of this deque if it is possible to do so immediately without violating capacity restrictions, throwing an `IllegalStateException` if no space is currently available.
`void` | `addLast(java.lang.Object e)` Inserts the specified element at the end of this deque if it is possible to do so immediately without violating capacity restrictions, throwing an `IllegalStateException` if no space is currently available.
`void` | `clear()` Atomically removes all of the elements from this deque.
`boolean` | `contains(java.lang.Object o)` Returns `true` if this deque contains the specified element.
`java.util.Iterator` | `descendingIterator()` Returns an iterator over the elements in this deque in reverse sequential order.
`int` | `drainTo(java.util.Collection c)` Removes all available elements from this queue and adds them to the given collection.
`int` | `drainTo(java.util.Collection c, int maxElements)` Removes at most the given number of available elements from this queue and adds them to the given collection.
`java.lang.Object` | `element()` Retrieves, but does not remove, the head of the queue represented by this deque.
`java.lang.Object` | `getFirst()` Retrieves, but does not remove, the first element of this deque.
`java.lang.Object` | `getLast()` Retrieves, but does not remove, the last element of this deque.
`java.util.Iterator` | `iterator()` Returns an iterator over the elements in this deque in proper sequence.
`boolean` | `offer(java.lang.Object e)` Inserts the specified element into the queue represented by this deque (in other words, at the tail of this deque) if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available.
`boolean` | `offer(java.lang.Object e, long timeout, TimeUnit unit)` Inserts the specified element into the queue represented by this deque (in other words, at the tail of this deque), waiting up to the specified wait time if necessary for space to become available.
`boolean` | `offerFirst(java.lang.Object e)` Inserts the specified element at the front of this deque if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available.
`boolean` | `offerFirst(java.lang.Object e, long timeout, TimeUnit unit)` Inserts the specified element at the front of this deque, waiting up to the specified wait time if necessary for space to become available.
`boolean` | `offerLast(java.lang.Object e)` Inserts the specified element at the end of this deque if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available.
`boolean` | `offerLast(java.lang.Object e, long timeout, TimeUnit unit)` Inserts the specified element at the end of this deque, waiting up to the specified wait time if necessary for space to become available.
`java.lang.Object` | `peek()` Retrieves, but does not remove, the head of the queue represented by this deque (in other words, the first element of this deque), or returns `null` if this deque is empty.
`java.lang.Object` | `peekFirst()` Retrieves, but does not remove, the first element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `peekLast()` Retrieves, but does not remove, the last element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `poll()` Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), or returns `null` if this deque is empty.
`java.lang.Object` | `poll(long timeout, TimeUnit unit)` Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), waiting up to the specified wait time if necessary for an element to become available.
`java.lang.Object` | `pollFirst()` Retrieves and removes the first element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `pollFirst(long timeout, TimeUnit unit)` Retrieves and removes the first element of this deque, waiting up to the specified wait time if necessary for an element to become available.
`java.lang.Object` | `pollLast()` Retrieves and removes the last element of this deque, or returns `null` if this deque is empty.
`java.lang.Object` | `pollLast(long timeout, TimeUnit unit)` Retrieves and removes the last element of this deque, waiting up to the specified wait time if necessary for an element to become available.
`java.lang.Object` | `pop()` Pops an element from the stack represented by this deque.
`void` | `push(java.lang.Object e)` Pushes an element onto the stack represented by this deque.
`void` | `put(java.lang.Object e)` Inserts the specified element into the queue represented by this deque (in other words, at the tail of this deque), waiting if necessary for space to become available.
`void` | `putFirst(java.lang.Object e)` Inserts the specified element at the front of this deque, waiting if necessary for space to become available.
`void` | `putLast(java.lang.Object e)` Inserts the specified element at the end of this deque, waiting if necessary for space to become available.
`int` | `remainingCapacity()` Returns the number of additional elements that this deque can ideally (in the absence of memory or resource constraints) accept without blocking.
`java.lang.Object` | `remove()` Retrieves and removes the head of the queue represented by this deque.
`boolean` | `remove(java.lang.Object o)` Removes the first occurrence of the specified element from this deque.
`java.lang.Object` | `removeFirst()` Retrieves and removes the first element of this deque.
`boolean` | `removeFirstOccurrence(java.lang.Object o)` Removes the first occurrence of the specified element from this deque.
`java.lang.Object` | `removeLast()` Retrieves and removes the last element of this deque.
`boolean` | `removeLastOccurrence(java.lang.Object o)` Removes the last occurrence of the specified element from this deque.
`int` | `size()` Returns the number of elements in this deque.
`java.lang.Object` | `take()` Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), waiting if necessary until an element becomes available.
`java.lang.Object` | `takeFirst()` Retrieves and removes the first element of this deque, waiting if necessary until an element becomes available.
`java.lang.Object` | `takeLast()` Retrieves and removes the last element of this deque, waiting if necessary until an element becomes available.
`java.lang.Object[]` | `toArray()` Returns an array containing all of the elements in this deque, in proper sequence (from first to last element).
`java.lang.Object[]` | `toArray(java.lang.Object[] a)` Returns an array containing all of the elements in this deque, in proper sequence; the runtime type of the returned array is that of the specified array.
`java.lang.String` | `toString()`

Methods inherited from class edu.emory.mathcs.backport.java.util.AbstractQueue
`addAll`

Methods inherited from class java.util.AbstractCollection
`containsAll, isEmpty, removeAll, retainAll`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`addAll, containsAll, equals, hashCode, isEmpty, removeAll, retainAll`

Constructor Detail

### LinkedBlockingDeque

    public LinkedBlockingDeque()

  Creates a `LinkedBlockingDeque` with a capacity of `Integer.MAX_VALUE`.

### LinkedBlockingDeque

    public LinkedBlockingDeque(int capacity)

  Creates a `LinkedBlockingDeque` with the given (fixed) capacity.

Parameters:
  `capacity` - the capacity of this deque
Throws:
  `java.lang.IllegalArgumentException` - if `capacity` is less than 1

### LinkedBlockingDeque

    public LinkedBlockingDeque(java.util.Collection c)

  Creates a `LinkedBlockingDeque` with a capacity of `Integer.MAX_VALUE`, initially containing the elements of the given collection, added in traversal order of the collection's iterator.

Parameters:
  `c` - the collection of elements to initially contain
Throws:
  `java.lang.NullPointerException` - if the specified collection or any of its elements are null

Method Detail

### addFirst

    public void addFirst(java.lang.Object e)

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the front of this deque if it is possible to do so immediately without violating capacity restrictions, throwing an `IllegalStateException` if no space is currently available. When using a capacity-restricted deque, it is generally preferable to use `offerFirst`.

  Specified by:
    `addFirst` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.IllegalStateException` - if the element cannot be added at this time due to capacity restrictions
    `java.lang.NullPointerException` - if the specified element is null

### addLast

    public void addLast(java.lang.Object e)

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the end of this deque if it is possible to do so immediately without violating capacity restrictions, throwing an `IllegalStateException` if no space is currently available. When using a capacity-restricted deque, it is generally preferable to use `offerLast`.

  Specified by:
    `addLast` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.IllegalStateException` - if the element cannot be added at this time due to capacity restrictions
    `java.lang.NullPointerException` - if the specified element is null

### offerFirst

    public boolean offerFirst(java.lang.Object e)

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the front of this deque if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available. When using a capacity-restricted deque, this method is generally preferable to the `addFirst` method, which can fail to insert an element only by throwing an exception.

  Specified by:
    `offerFirst` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### offerLast

    public boolean offerLast(java.lang.Object e)

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the end of this deque if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available. When using a capacity-restricted deque, this method is generally preferable to the `addLast` method, which can fail to insert an element only by throwing an exception.

  Specified by:
    `offerLast` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### putFirst

    public void putFirst(java.lang.Object e)
                  throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the front of this deque, waiting if necessary for space to become available.

  Specified by:
    `putFirst` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null
    `java.lang.InterruptedException` - if interrupted while waiting

### putLast

    public void putLast(java.lang.Object e)
                 throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the end of this deque, waiting if necessary for space to become available.

  Specified by:
    `putLast` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null
    `java.lang.InterruptedException` - if interrupted while waiting

### offerFirst

    public boolean offerFirst(java.lang.Object e,
                              long timeout,
                              TimeUnit unit)
                       throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the front of this deque, waiting up to the specified wait time if necessary for space to become available.

  Specified by:
    `offerFirst` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    `true` if successful, or `false` if the specified waiting time elapses before space is available
  Throws:
    `java.lang.NullPointerException` - if the specified element is null
    `java.lang.InterruptedException` - if interrupted while waiting

### offerLast

    public boolean offerLast(java.lang.Object e,
                             long timeout,
                             TimeUnit unit)
                      throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Inserts the specified element at the end of this deque, waiting up to the specified wait time if necessary for space to become available.

  Specified by:
    `offerLast` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    `true` if successful, or `false` if the specified waiting time elapses before space is available
  Throws:
    `java.lang.NullPointerException` - if the specified element is null
    `java.lang.InterruptedException` - if interrupted while waiting

### removeFirst

    public java.lang.Object removeFirst()

  Description copied from interface: `Deque`
  Retrieves and removes the first element of this deque. This method differs from `pollFirst` only in that it throws an exception if this deque is empty.

  Specified by:
    `removeFirst` in interface `Deque`
  Returns:
    the head of this deque
  Throws:
    `java.util.NoSuchElementException`

### removeLast

    public java.lang.Object removeLast()

  Description copied from interface: `Deque`
  Retrieves and removes the last element of this deque. This method differs from `pollLast` only in that it throws an exception if this deque is empty.

  Specified by:
    `removeLast` in interface `Deque`
  Returns:
    the tail of this deque
  Throws:
    `java.util.NoSuchElementException`

### pollFirst

    public java.lang.Object pollFirst()

  Description copied from interface: `Deque`
  Retrieves and removes the first element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `pollFirst` in interface `Deque`
  Returns:
    the head of this deque, or `null` if this deque is empty

### pollLast

    public java.lang.Object pollLast()

  Description copied from interface: `Deque`
  Retrieves and removes the last element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `pollLast` in interface `Deque`
  Returns:
    the tail of this deque, or `null` if this deque is empty

### takeFirst

    public java.lang.Object takeFirst()
                               throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the first element of this deque, waiting if necessary until an element becomes available.

  Specified by:
    `takeFirst` in interface `BlockingDeque`
  Returns:
    the head of this deque
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### takeLast

    public java.lang.Object takeLast()
                              throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the last element of this deque, waiting if necessary until an element becomes available.

  Specified by:
    `takeLast` in interface `BlockingDeque`
  Returns:
    the tail of this deque
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### pollFirst

    public java.lang.Object pollFirst(long timeout,
                                      TimeUnit unit)
                               throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the first element of this deque, waiting up to the specified wait time if necessary for an element to become available.

  Specified by:
    `pollFirst` in interface `BlockingDeque`
  Parameters:
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    the head of this deque, or `null` if the specified waiting time elapses before an element is available
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### pollLast

    public java.lang.Object pollLast(long timeout,
                                     TimeUnit unit)
                              throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the last element of this deque, waiting up to the specified wait time if necessary for an element to become available.

  Specified by:
    `pollLast` in interface `BlockingDeque`
  Parameters:
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    the tail of this deque, or `null` if the specified waiting time elapses before an element is available
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### getFirst

    public java.lang.Object getFirst()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the first element of this deque. This method differs from `peekFirst` only in that it throws an exception if this deque is empty.

  Specified by:
    `getFirst` in interface `Deque`
  Returns:
    the head of this deque
  Throws:
    `java.util.NoSuchElementException`

### getLast

    public java.lang.Object getLast()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the last element of this deque. This method differs from `peekLast` only in that it throws an exception if this deque is empty.

  Specified by:
    `getLast` in interface `Deque`
  Returns:
    the tail of this deque
  Throws:
    `java.util.NoSuchElementException`

### peekFirst

    public java.lang.Object peekFirst()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the first element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `peekFirst` in interface `Deque`
  Returns:
    the head of this deque, or `null` if this deque is empty

### peekLast

    public java.lang.Object peekLast()

  Description copied from interface: `Deque`
  Retrieves, but does not remove, the last element of this deque, or returns `null` if this deque is empty.

  Specified by:
    `peekLast` in interface `Deque`
  Returns:
    the tail of this deque, or `null` if this deque is empty

### removeFirstOccurrence

    public boolean removeFirstOccurrence(java.lang.Object o)

  Description copied from interface: `BlockingDeque`
  Removes the first occurrence of the specified element from this deque. If the deque does not contain the element, it is unchanged. More formally, removes the first element `e` such that `o.equals(e)` (if such an element exists). Returns `true` if this deque contained the specified element (or equivalently, if this deque changed as a result of the call).

  Specified by:
    `removeFirstOccurrence` in interface `BlockingDeque`
  Parameters:
    `o` - element to be removed from this deque, if present
  Returns:
    `true` if an element was removed as a result of this call

### removeLastOccurrence

    public boolean removeLastOccurrence(java.lang.Object o)

  Description copied from interface: `BlockingDeque`
  Removes the last occurrence of the specified element from this deque. If the deque does not contain the element, it is unchanged. More formally, removes the last element `e` such that `o.equals(e)` (if such an element exists). Returns `true` if this deque contained the specified element (or equivalently, if this deque changed as a result of the call).

  Specified by:
    `removeLastOccurrence` in interface `BlockingDeque`
  Parameters:
    `o` - element to be removed from this deque, if present
  Returns:
    `true` if an element was removed as a result of this call

### add

    public boolean add(java.lang.Object e)

  Inserts the specified element at the end of this deque unless it would violate capacity restrictions. When using a capacity-restricted deque, it is generally preferable to use method `offer`.

  This method is equivalent to `addLast(java.lang.Object)`.

  Specified by:
    `add` in interface `BlockingDeque`
  Overrides:
    `add` in class `AbstractQueue`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Collection.add(java.lang.Object)`)
  Throws:
    `java.lang.IllegalStateException` - if the element cannot be added at this time due to capacity restrictions
    `java.lang.NullPointerException` - if the specified element is null

### offer

    public boolean offer(java.lang.Object e)

  Description copied from interface: `BlockingDeque`
  Inserts the specified element into the queue represented by this deque (in other words, at the tail of this deque) if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available. When using a capacity-restricted deque, this method is generally preferable to the `BlockingDeque.add(java.lang.Object)` method, which can fail to insert an element only by throwing an exception.

  This method is equivalent to `offerLast`.

  Specified by:
    `offer` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### put

    public void put(java.lang.Object e)
             throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Inserts the specified element into the queue represented by this deque (in other words, at the tail of this deque), waiting if necessary for space to become available.

  This method is equivalent to `putLast`.

  Specified by:
    `put` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.NullPointerException` - if the specified element is null
    `java.lang.InterruptedException` - if interrupted while waiting

### offer

    public boolean offer(java.lang.Object e,
                         long timeout,
                         TimeUnit unit)
                  throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Inserts the specified element into the queue represented by this deque (in other words, at the tail of this deque), waiting up to the specified wait time if necessary for space to become available.

  This method is equivalent to `offerLast`.

  Specified by:
    `offer` in interface `BlockingDeque`
  Parameters:
    `e` - the element to add
  Returns:
    `true` if the element was added to this deque, else `false`
  Throws:
    `java.lang.NullPointerException` - if the specified element is null
    `java.lang.InterruptedException` - if interrupted while waiting

### remove

    public java.lang.Object remove()

  Retrieves and removes the head of the queue represented by this deque. This method differs from `poll` only in that it throws an exception if this deque is empty.

  This method is equivalent to `removeFirst`.

  Specified by:
    `remove` in interface `BlockingDeque`
  Overrides:
    `remove` in class `AbstractQueue`
  Returns:
    the head of the queue represented by this deque
  Throws:
    `java.util.NoSuchElementException` - if this deque is empty

### poll

    public java.lang.Object poll()

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), or returns `null` if this deque is empty.

  This method is equivalent to `Deque.pollFirst()`.

  Specified by:
    `poll` in interface `BlockingDeque`
  Returns:
    the head of this deque, or `null` if this deque is empty

### take

    public java.lang.Object take()
                          throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), waiting if necessary until an element becomes available.

  This method is equivalent to `takeFirst`.

  Specified by:
    `take` in interface `BlockingDeque`
  Returns:
    the head of this deque
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### poll

    public java.lang.Object poll(long timeout,
                                 TimeUnit unit)
                          throws java.lang.InterruptedException

  Description copied from interface: `BlockingDeque`
  Retrieves and removes the head of the queue represented by this deque (in other words, the first element of this deque), waiting up to the specified wait time if necessary for an element to become available.

  This method is equivalent to `pollFirst`.

  Specified by:
    `poll` in interface `BlockingDeque`
  Returns:
    the head of this deque, or `null` if the specified waiting time elapses before an element is available
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### element

    public java.lang.Object element()

  Retrieves, but does not remove, the head of the queue represented by this deque. This method differs from `peek` only in that it throws an exception if this deque is empty.

  This method is equivalent to `getFirst`.

  Specified by:
    `element` in interface `BlockingDeque`
  Overrides:
    `element` in class `AbstractQueue`
  Returns:
    the head of the queue represented by this deque
  Throws:
    `java.util.NoSuchElementException` - if this deque is empty

### peek

    public java.lang.Object peek()

  Description copied from interface: `BlockingDeque`
  Retrieves, but does not remove, the head of the queue represented by this deque (in other words, the first element of this deque), or returns `null` if this deque is empty.

  This method is equivalent to `peekFirst`.

  Specified by:
    `peek` in interface `BlockingDeque`
  Returns:
    the head of this deque, or `null` if this deque is empty

### remainingCapacity

    public int remainingCapacity()

  Returns the number of additional elements that this deque can ideally (in the absence of memory or resource constraints) accept without blocking. This is always equal to the initial capacity of this deque less the current `size` of this deque.

  Note that you cannot always tell if an attempt to insert an element will succeed by inspecting `remainingCapacity` because it may be the case that another thread is about to insert or remove an element.

  Specified by:
    `remainingCapacity` in interface `BlockingQueue`
  Returns:
    the remaining capacity

### drainTo

    public int drainTo(java.util.Collection c)

  Description copied from interface: `BlockingQueue`
  Removes all available elements from this queue and adds them to the given collection. This operation may be more efficient than repeatedly polling this queue. A failure encountered while attempting to add elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue`
  Parameters:
    `c` - the collection to transfer elements into
  Returns:
    the number of elements transferred
  Throws:
    `java.lang.UnsupportedOperationException` - if addition of elements is not supported by the specified collection
    `java.lang.ClassCastException` - if the class of an element of this queue prevents it from being added to the specified collection
    `java.lang.NullPointerException` - if the specified collection is null
    `java.lang.IllegalArgumentException` - if the specified collection is this queue, or some property of an element of this queue prevents it from being added to the specified collection

### drainTo

    public int drainTo(java.util.Collection c,
                       int maxElements)

  Description copied from interface: `BlockingQueue`
  Removes at most the given number of available elements from this queue and adds them to the given collection. A failure encountered while attempting to add elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue`
  Parameters:
    `c` - the collection to transfer elements into
    `maxElements` - the maximum number of elements to transfer
  Returns:
    the number of elements transferred
  Throws:
    `java.lang.UnsupportedOperationException` - if addition of elements is not supported by the specified collection
    `java.lang.ClassCastException` - if the class of an element of this queue prevents it from being added to the specified collection
    `java.lang.NullPointerException` - if the specified collection is null
    `java.lang.IllegalArgumentException` - if the specified collection is this queue, or some property of an element of this queue prevents it from being added to the specified collection

### push

    public void push(java.lang.Object e)

  Description copied from interface: `BlockingDeque`
  Pushes an element onto the stack represented by this deque. In other words, inserts the element at the front of this deque unless it would violate capacity restrictions.

  This method is equivalent to `addFirst`.

  Specified by:
    `push` in interface `BlockingDeque`
  Throws:
    `java.lang.IllegalStateException` - if the element cannot be added at this time due to capacity restrictions
    `java.lang.NullPointerException` - if the specified element is null

### pop

    public java.lang.Object pop()

  Description copied from interface: `Deque`
  Pops an element from the stack represented by this deque. In other words, removes and returns the first element of this deque.

  This method is equivalent to `Deque.removeFirst()`.

  Specified by:
    `pop` in interface `Deque`
  Returns:
    the element at the front of this deque (which is the top of the stack represented by this deque)
  Throws:
    `java.util.NoSuchElementException`

### remove

    public boolean remove(java.lang.Object o)

  Removes the first occurrence of the specified element from this deque. If the deque does not contain the element, it is unchanged. More formally, removes the first element `e` such that `o.equals(e)` (if such an element exists). Returns `true` if this deque contained the specified element (or equivalently, if this deque changed as a result of the call).

  This method is equivalent to `removeFirstOccurrence`.

  Specified by:
    `remove` in interface `BlockingDeque`
  Parameters:
    `o` - element to be removed from this deque, if present
  Returns:
    `true` if this deque changed as a result of the call

### size

    public int size()

  Returns the number of elements in this deque.

  Specified by:
    `size` in interface `BlockingDeque`
  Returns:
    the number of elements in this deque

### contains

    public boolean contains(java.lang.Object o)

  Returns `true` if this deque contains the specified element. More formally, returns `true` if and only if this deque contains at least one element `e` such that `o.equals(e)`.

  Specified by:
    `contains` in interface `BlockingDeque`
  Parameters:
    `o` - object to be checked for containment in this deque
  Returns:
    `true` if this deque contains the specified element

### toArray

    public java.lang.Object[] toArray()

  Returns an array containing all of the elements in this deque, in proper sequence (from first to last element).

  The returned array will be "safe" in that no references to it are maintained by this deque. (In other words, this method must allocate a new array). The caller is thus free to modify the returned array.

  This method acts as bridge between array-based and collection-based APIs.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Returns:
    an array containing all of the elements in this deque

### toArray

    public java.lang.Object[] toArray(java.lang.Object[] a)

  Returns an array containing all of the elements in this deque, in proper sequence; the runtime type of the returned array is that of the specified array. If the deque fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this deque.

  If this deque fits in the specified array with room to spare (i.e., the array has more elements than this deque), the element in the array immediately following the end of the deque is set to `null`.

  Like the `toArray()` method, this method acts as bridge between array-based and collection-based APIs. Further, this method allows precise control over the runtime type of the output array, and may, under certain circumstances, be used to save allocation costs.

  Suppose `x` is a deque known to contain only strings. The following code can be used to dump the deque into a newly allocated array of `String`:

           String[] y = x.toArray(new String[0]);

  Note that `toArray(new Object[0])` is identical in function to `toArray()`.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Parameters:
    `a` - the array into which the elements of the deque are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose
  Returns:
    an array containing all of the elements in this deque
  Throws:
    `java.lang.ArrayStoreException` - if the runtime type of the specified array is not a supertype of the runtime type of every element in this deque
    `java.lang.NullPointerException` - if the specified array is null

### toString

    public java.lang.String toString()

### clear

    public void clear()

  Atomically removes all of the elements from this deque. The deque will be empty after this call returns.

  Specified by:
    `clear` in interface `java.util.Collection`
  Overrides:
    `clear` in class `AbstractQueue`

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over the elements in this deque in proper sequence. The elements will be returned in order from first (head) to last (tail). The returned `Iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `iterator` in interface `BlockingDeque`
  Returns:
    an iterator over the elements in this deque in proper sequence

### descendingIterator

    public java.util.Iterator descendingIterator()

  Returns an iterator over the elements in this deque in reverse sequential order. The elements will be returned in order from last (tail) to first (head). The returned `Iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `descendingIterator` in interface `Deque`
  Returns:
    an iterator over the elements in this deque in reverse sequence

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD